<template>
  <div class="supplier pagePadding">
    <ex-table
      v-loading="loading"
      v-if="powers.some((i) => i == '001')"
      :table="table"
      :data="tableData"
      :columns="columns"
      :page="pageInfo"
      :size="size"
      @page-curr-change="handlePageChange"
      @page-size-change="handleSizeChange"
      @screen-reset="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
      @screen-submit="
        pageInfo.curr = 1;
        parmValue.page = 1;
        searchList();
      "
    >
      <template #table-header="{}">
        <div style="width: 100%">
          <el-row style="padding: 0 0 10px 80px">
            <el-col :span="6" style="width: 303px">
              <period-date-picker
                :type="1"
                :width="'135px'"
                :size="searchSize"
                :start="parmValue.start"
                :end="parmValue.end"
                @timeReturned="handleTime"
              />
            </el-col>
            <el-col :span="4" style="width: 160px">
              <el-select
                v-model="parmValue.status"
                filterable
                clearable
                :size="searchSize"
                placeholder="状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in statusList"
                  :key="'status' + item.code"
                  :label="item.name"
                  :value="item.code"
                />
              </el-select>
            </el-col>
            <el-col :span="4" style="width: 200px; padding: 0 0 0 10px">
              <el-select
                v-model="parmValue.ocr_status"
                filterable
                clearable
                :size="searchSize"
                placeholder="营业执照识别状态"
                style="width: 100%"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
              >
                <el-option
                  v-for="item in ocr_status"
                  :key="'ocr_status' + item.id"
                  :label="item.label"
                  :value="item.id"
                />
              </el-select>
            </el-col>

            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="primary" :size="searchSize" @click="searchList">
                刷新
              </el-button>
            </el-col>
            <el-col :span="3" class="fr" style="width: 66px; padding: 0 0 0 10px">
              <el-button type="warning" :size="searchSize" @click="restSearch">
                重置
              </el-button>
            </el-col>
          </el-row>
          <el-row>
            <el-col :span="4" style="width: 333px">
              <el-input
                :size="searchSize"
                v-model="parmValue.name"
                :maxlength="40"
                @blur="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="供应商名称"
              ></el-input>
            </el-col>
            <el-col :span="4" style="width: 120px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="parmValue.creater"
                :maxlength="40"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="创建人"
              ></el-input>
            </el-col>
            <el-col :span="4" style="width: 170px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="parmValue.company_name"
                :maxlength="40"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="创建人部门"
              ></el-input>
            </el-col>
            <el-col :span="4" style="width: 120px; padding: 0 0 0 10px">
              <el-input
                :size="searchSize"
                v-model="parmValue.person"
                :maxlength="40"
                @change="
                  pageInfo.curr = 1;
                  parmValue.page = 1;
                  searchList();
                "
                placeholder="负责人"
              ></el-input>
            </el-col>
            <el-col
              :span="3"
              class="fr"
              style="width: 66px; padding: 0 0 0 10px"
              v-if="powers.some((i) => i == '003')"
            >
              <el-button
                :size="searchSize"
                type="success"
                style="float: right"
                @click="routeGoto('supplierDetail', { id: 'add', type: 'add' })"
              >
                添加
              </el-button>
            </el-col>
          </el-row>
        </div></template
      >
      <template #status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.status == '0' ? 'warning' : ''"
          v-text="
            (statusOptions.find((item) => item.id == scope.row.status) || {}).label ||
            '--'
          "
        ></el-tag>
      </template>
      <template #ocr_status="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="
            scope.row.ocr_status == '0'
              ? 'info'
              : scope.row.ocr_status == '1'
              ? 'primary'
              : scope.row.ocr_status == '2'
              ? 'danger'
              : ''
          "
          v-text="
            (ocr_status.find((item) => item.id == scope.row.ocr_status) || {}).label ||
            '--'
          "
        ></el-tag>
      </template>
      <template #is_upgrade="{ scope }">
        <el-tag
          :size="tablebtnSize"
          :type="scope.row.is_upgrade + '' === '1' ? 'success' : ''"
          v-text="
            (
              is_upgrade_options.find((item) => item.id == scope.row.is_upgrade + '') ||
              {}
            ).label || '--'
          "
        ></el-tag>
      </template>

      <template #operation="{ scope }">
        <el-tooltip
          v-if="powers.some((i) => i == '007')"
          effect="dark"
          content="详情"
          placement="top"
        >
          <i
            class="el-icon-view tb-icon"
            @click="getRouter('supplierDetail', scope.row.code)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '005')"
          effect="dark"
          content="修改"
          placement="top"
        >
          <i class="el-icon-edit tb-icon" @click="gotoEdit(scope.row, '005')"></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '004') && scope.row.status + '' === '1'"
          effect="dark"
          content="禁用"
          placement="top"
        >
          <i
            class="el-icon-video-pause tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '004') && scope.row.status + '' === '0'"
          effect="dark"
          content="启用"
          placement="top"
        >
          <i
            class="el-icon-video-play tb-icon"
            @click="changeStatus(scope.row.id, scope.row.status)"
          ></i>
        </el-tooltip>
        <el-tooltip
          v-if="powers.some((i) => i == '006')"
          effect="dark"
          content="删除"
          placement="top"
        >
          <i class="el-icon-delete tb-icon" @click="deleteItem(scope.row.id)"></i>
        </el-tooltip>
        <el-tooltip
          effect="dark"
          content="升级"
          placement="top"
            v-if="scope.row.is_upgrade + '' === '0' && isSupertube"
        >
          <i class="el-icon-top tb-icon" @click="openModal(scope.row)"></i>
        </el-tooltip>
      </template>
    </ex-table>
    <no-auth v-else></no-auth>
    <!-- 升级为业务公司-->
    <add-edit
      :id="modelId"
      :show-model="showModel"
      :sitem="modelSitem"
      @refresh="searchList"
      @cancel="showModel = false"
    />
  </div>
</template>
<script>
import asyncRequest from "@/apis/service/serviceParam/supplier";
import { statusList } from "@/assets/js/statusList";
import roleLevel from "@/assets/js/roleLevel";
import mixinPage from "@/mixins/elPaginationHandle";
import { mapGetters } from "vuex";
import addEdit from "./components/addEdit";
import resToken from "@/mixins/resToken";
export default {
  name: "supplier",
  mixins: [mixinPage, resToken],
  components: {
    addEdit,
  },
  computed: {
    //组件SIZE设置
    ...mapGetters(["tablebtnSize", "searchSize", "size", "isSupertube"]),
    powers() {
      const tran =
        this.$store.getters.btnList.find((item) => item.menu_route == "supplier") || {};
      const { action } = tran ?? {};
      return action ?? [];
    },
  },
  data() {
    return {
      statusList: statusList,
      roleLevel: roleLevel,
      loading: true,
      showModel: false,
      modelId: "",
      modelSitem: null,
      stype: {},
      is_upgrade_options: [
        { id: "1", label: "已升级" },
        { id: "0", label: "未升级" },
      ],
      parmValue: {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        creater: "",
        company_name: "", //创建人部门
        name: "",
        ocr_status: "",
      },
      // 状态
      statusOptions: [
        { id: "0", label: "禁用" },
        { id: "1", label: "启用" },
      ],
      ocr_status: [
        { id: "0", label: "未上传" },
        { id: "1", label: "识别成功" },
        { id: "2", label: "识别失败" },
      ],
      // 表格 - 数据
      tableData: [],
      // 表格 - 参数
      table: {
        stripe: true,
        border: true,
        _defaultHeader_: ["setcol"],
      },
      // 表格 - 分页
      pageInfo: {
        size: 15,
        curr: 1,
        total: 0,
      },
      // 表格 - 列参数
      columns: [
        {
          prop: "code",
          label: "编号",
          minWidth: "160",
        },
        {
          prop: "name",
          label: "供应商名称",
          minWidth: "200",
        },
        {
          prop: "status",
          label: "状态",
          minWidth: "60",
          _slot_: "status",
        },
        {
          prop: "ocr_status",
          label: "营业执照识别状态",
          width: "120",
          _slot_: "ocr_status",
        },
        {
          prop: "is_upgrade",
          label: "是否升级为业务公司",
          width: "130",
          _slot_: "is_upgrade",
        },
        {
          prop: "legaler",
          label: "法人",
          minWidth: "80",
        },
        {
          prop: "person",
          label: "负责人",
          minWidth: "100",
        },
        // {
        //   prop: "company_name",
        //   label: "创建人部门",
        //   minWidth: "120px",
        // },
        {
          prop: "creater",
          label: "创建人",
          minWidth: "80",
        },
        {
          prop: "addtime",
          label: "创建时间",
          width: "145",
        },
        {
          prop: "",
          label: "操作",
          fixed: "right",
          width: "170",
          _noset_: true,
          _slot_: "operation",
        },
      ],
    };
  },
  mounted() {
    const { back } = this.$route.query;
    if (back) {
      this.parmValue = JSON.parse(back);
      console.log(this.parmValue);
      const { page, size } = this.parmValue;
      // this.parmValue.start = start || last_start;
      // this.parmValue.end = end || last_end;
      // if(this.parmValue.brandid.length>0){
      //   this.brandid = [this.parmValue.brandid] ;
      // }

      this.pageInfo = {
        size: size,
        curr: page,
        total: 0,
      };
      //多选条件
      // this.select = this.parmValue.select;
      // this.sselect = this.parmValue.sselect;
      // this.sinput = this.parmValue.sinput
    } else {
      //  this.select = "1";
      //  this.sselect = "创建时间"
    }
    this.searchList();
  },
  methods: {
    getRouter(toRouter, queryId) {
      if (toRouter && queryId) {
        let model = {
          id: queryId,
          type: "view",
        };

        //有多选框的条件
        // this.parmValue.select = this.select ;
        // this.parmValue.sselect = this.sselect ;
        // this.parmValue.sinput= this.sinput;
        //
        console.log(queryId);
        let routerModel = {
          options: JSON.parse(JSON.stringify(this.parmValue)),
          router: this.$route.path,
        };
        model.preModel = JSON.stringify(routerModel);

        this.routeGoto(toRouter, model);
      } else {
        this.$message.warning("暂未找到相关流程！");
      }
    },
    restSearch() {
      // 表格 - 分页
      this.pageInfo = {
        size: 15,
        curr: 1,
        total: 0,
      };
      this.parmValue = {
        page: 1, // 页码
        size: 15, // 每页显示条数
        start: "",
        end: "",
        status: "",
        company_name: "", //创建人部门
        creater: "",
        name: "",
        person: "",
        ocr_status: "",
      };
      this.searchList();
    },
    openModal(row) {
      const { id } = row;
      this.showModel = true;
      this.modelId = id;
      this.modelSitem = row;
    },
    // 时间
    async handleTime(e) {
      this.parmValue.start = e.startTime || "";
      this.parmValue.end = e.endTime || "";
      if (
        (this.parmValue.start !== "" && this.parmValue.end !== "") ||
        (this.parmValue.start === "" && this.parmValue.end === "")
      ) {
        this.pageInfo.curr = 1;
        this.parmValue.page = 1;
        await this.searchList();
      }
    },
    gotoEdit(row, type) {
      const { status } = row;
      if (type === "005" && status + "" === "1") {
        this.$message.warning("禁用后，才可以修改！");
        return;
      }
      this.routeGoto("supplierDetail", {
        id: row.code,
        type: "edit",
      });
    },
    /**
     * 启用/禁用
     * @param {String} id id
     * @param {String} status 0-禁用 1-启用
     */
    async changeStatus(id, status) {
      await this.$confirm(`确定要改为${status + "" === "1" ? "禁用" : "启用"}？`, {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          this.loading = true;
          const model = {
            id: id,
            status: status + "" === "1" ? "0" : "1",
          };
          const res = await asyncRequest.status(model);
          if (res && res.code === 0) {
            this.loading = false;
            this.$notify.success({
              title: "状态修改成功！",
              message: "",
            });
            await this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.loading = false;
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    async deleteItem(id) {
      await this.$confirm("确定要删除？", {
        confirmButtonText: "确定",
        cancelButtonText: "取消",
        type: "warning",
      })
        .then(async () => {
          const model = {
            id: id,
          };
          const res = await asyncRequest.delete(model);
          if (res && res.code === 0) {
            this.$notify.success({
              title: "删除成功",
              message: "",
            });
            this.searchList();
          } else if (res && res.code >= 100 && res.code <= 104) {
            await this.logout();
          } else {
            this.$message.warning(res.message);
          }
        })
        .catch(() => {
          console.log("取消");
        });
    },
    // 刷新表格
    async searchList() {
      if (
        (this.parmValue.start !== "" && this.parmValue.end === "") ||
        (this.parmValue.start == "" && this.parmValue.end != "")
      ) {
        this.$message.warning("开始时间和结束时间不能为空");
        return;
      }
      this.loading = true;
      const { code, data, message } = await asyncRequest.list(this.parmValue);
      let scode = parseInt(code + "");
      if (scode === 0) {
        const { list, count } = data;
        this.tableData = list;
        this.pageInfo.total = Number(count + "");
      } else if (scode >= 100 && scode <= 104) {
        await this.logout();
      } else {
        this.tableData = [];
        this.pageInfo.total = 0;
      }
      this.loading = false;
    },
  },
};
</script>

<style lang="scss" scoped></style>
